#!/usr/bin/python2.7
# -*- coding: utf-8 -*-
#
# Copyright (C) 1998-2011  agorum Software GmbH
#
# This file is part of agorum core
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.


#
# Phyton script that is calles, when something changes at a user in ldap (del, create, update)
#
__package__='' 	# workaround for PEP 366

name='agorumcore'
description='agorum core'
filter='(objectClass=sambaSamAccount)'

# attributes to react on
attributes=['uid', 'uidNumber', 'cn', 
            'agorumcoreAccount', 'sambaLMPassword', 'sambaNTPassword', 
            'givenName', 'sn', 'description', 'mailPrimaryAddress']

import subprocess

import listener
import univention_baseconfig
import univention.debug
import os
import sys
import univention.utf8
import types
import time
import datetime
import calendar
import cPickle
import uuid
import time

folder='/opt/agorum/agorumcore/jboss/server/default/userqueue/'

# use the modrdn listener extension 
modrdn="1" 

def handler(dn, new, old, command):
  # Funktion um in eine Textdatei zu schreiben, mit setuid(0)
  # da der Handler als root ausgefuehrt wird:
	
  def writeUser(old, new, mode, command):
    listener.setuid(0)
    
    # create destination directory if not present
    d = os.path.dirname(folder)
    if not os.path.exists(d):
      os.makedirs(d)
      
    if not os.path.exists(os.path.join(folder, 'tmp')): 
      os.mkdir(os.path.join(folder, 'tmp')) 

    old_dn=None 
    if os.path.exists(os.path.join(folder, 'tmp','old_dn')): 
      # There is an old tmp-entry, so load it
      f=open(os.path.join(folder, 'tmp','old_dn'),'r') 
      old_dn=cPickle.load(f) 
      f.close() 
      os.remove(os.path.join(folder, 'tmp','old_dn'))
      
    if command == 'r':
      # it is a rename
      # so create a tmp file, with all information
      filename=os.path.join(folder, 'tmp','old_dn') 
      f=open(filename, 'w+') 
      os.chmod(filename, 0600) 
      cPickle.dump(old, f) 
      f.close() 
      
    elif (mode == 'create' and 'uid' in new) or (mode == 'update' and 'uid' in new and 'uid' in old) or (mode == 'delete' and 'uid' in old):
        
      destFile = ''
      try:
        
        theUid = ''
        if 'uidNumber' in new:
          theUid = new['uidNumber'][0]

        elif 'uidNumber' in old:
          theUid = old['uidNumber'][0]
          
        # create the destination file
        dt = datetime.datetime.now()
        ts = calendar.timegm(dt.utctimetuple())
        
        destFile = '%suser_%s_%s_%s.xml'%(folder, ts, theUid, uuid.uuid1())

        univention.debug.debug(univention.debug.LISTENER,
            univention.debug.INFO,
            '### write to file: %s'%(destFile))
            
        # delete file if present
        if os.path.exists(destFile):
          os.remove(destFile)
        
        o=open(destFile,'a')
        try:
        
          # write to file
          o.write('<?xml version = "1.0" encoding="UTF-8"?>\n')
          o.write('<User>\n')
          if old_dn != None:
            o.write('  <Mode>update</Mode>\n')
          else:
            o.write('  <Mode>%s</Mode>\n'%(mode))
          
          if old_dn != None: 
            # there is a tmp old, so use it (renaming)
            o.write('  <Old>\n')
            writeUserInfo(old_dn, o, command);
            o.write('  </Old>\n')
            
          elif 'uid' in old:
            o.write('  <Old>\n')
            writeUserInfo(old, o, command);
            o.write('  </Old>\n')
          
          if 'uid' in new:
            o.write('  <New>\n')
            writeUserInfo(new, o, command);
            o.write('  </New>\n')

          o.write('</User>\n')
        
        except Exception, e:
          univention.debug.debug(univention.debug.LISTENER,
            univention.debug.ERROR,
            'Failed to write to file "%s": %s'%(destFile, str(e)))
        
        o.close()
        
      except Exception, e:
        univention.debug.debug(univention.debug.LISTENER,
          univention.debug.ERROR,
          'Failed to write to file "%s", %s: '%(destFile, str(e)))
          
    listener.unsetuid()
      
  # end of writeUser  
  
  def writeUserInfo(obj, f, command):
    if 'uid' in obj:
      f.write('   <Uid><![CDATA[%s]]></Uid>\n'%(obj['uid'][0]))
      
    if 'sambaLMPassword' in obj:
      f.write('   <SambaLMPassword><![CDATA[%s]]></SambaLMPassword>\n'%(obj['sambaLMPassword'][0]))

    if 'uidNumber' in obj:
      f.write('   <UidNumber><![CDATA[%s]]></UidNumber>\n'%(obj['uidNumber'][0]))
      
    if 'cn' in obj:
      f.write('   <Cn><![CDATA[%s]]></Cn>\n'%(obj['cn'][0]))

    if 'agorumcoreAccount' in obj:
      f.write('   <AgorumcoreAccount><![CDATA[%s]]></AgorumcoreAccount>\n'%(obj['agorumcoreAccount'][0]))

    if 'sambaNTPassword' in obj:
      f.write('   <SambaNTPassword><![CDATA[%s]]></SambaNTPassword>\n'%(obj['sambaNTPassword'][0]))
      
    if 'givenName' in obj:
      f.write('   <GivenName><![CDATA[%s]]></GivenName>\n'%(obj['givenName'][0]))
    else:
      f.write('   <GivenName><![CDATA[]]></GivenName>\n')

    if 'sn' in obj:
      f.write('   <SurName><![CDATA[%s]]></SurName>\n'%(obj['sn'][0]))
    else:
      f.write('   <SurName><![CDATA[]]></SurName>\n')

    if 'description' in obj:
      f.write('   <Description><![CDATA[%s]]></Description>\n'%(obj['description'][0]))
    else:
      f.write('   <Description><![CDATA[]]></Description>\n')
      
    if 'mailPrimaryAddress' in obj:
      f.write('   <MailPrimaryAddress><![CDATA[%s]]></MailPrimaryAddress>\n'%(obj['mailPrimaryAddress'][0]))
      
  # end of writeUserInfo
    
  # ----- Wenn ein Objekt veraendert wird:
  if new and old:
		# Schliesst Computerobjekte aus:
    if not new['uid'][0][-1:] == '$' and not old['uid'][0][-1:] == '$':
      writeUser(old, new, 'update', command)
      
  # ----- Wenn ein neues Objekt erzeugt wird:
  #	(Nach einer Initialisierung sind alle Benutzer "neu"!)
  if new and not old:
    writeUser(old, new, 'create', command)
  
  # ----- Wenn ein Objekt geloescht wird:
  if old and not new:
    writeUser(old, new, 'delete', command)
 
  time.sleep(0.1)